using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using LinearProgramming;
using ALM;

namespace LayoutSpecTest
{
    class Program
    {
        static void Main(string[] args)
        {
            LayoutSpec ls = new LayoutSpec();
            XTab x1 = ls.AddXTab();
            YTab y1 = ls.AddYTab();

            Area a1 = ls.AddArea(ls.Left, ls.Top, x1, y1, null);
            Area a2 = ls.AddArea(x1, ls.Top, ls.Right, y1, null);
            Area a3 = ls.AddArea(ls.Left, y1, ls.Right, ls.Bottom, null);

            // give the two columns the same width and the two rows the same height
            ls.AddConstraint(2, x1, -1, ls.Right, OperatorType.EQ, 0);
            ls.AddConstraint(2, y1, -1, ls.Bottom, OperatorType.EQ, 0);

            Console.WriteLine(ls.MinSize + ", " + ls.PreferredSize + ", " + ls.MaxSize);

            a3.MaxContentSize = new Size(100, 80);
            Console.WriteLine(ls.MinSize + ", " + ls.PreferredSize + ", " + ls.MaxSize);

            a3.MinContentSize = new Size(50, 20);
            Console.WriteLine(ls.MinSize + ", " + ls.PreferredSize + ", " + ls.MaxSize);

            Console.ReadKey();
        }
    }
}
