using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.Layout;
using LinearProgramming;
using ALM;

namespace Test1
{
    public partial class Form1 : Form
    {
        ALMEngine le = new ALMEngine();

        public override LayoutEngine LayoutEngine
        {
            get { return le; }
        }

        public Form1()
        {
            InitializeComponent();

            LayoutSpec ls = new LayoutSpec();
            XTab x1 = ls.AddXTab();
            YTab y1 = ls.AddYTab();

            ls.AddArea(ls.Left, ls.Top, x1, y1, button1);
            ls.AddArea(x1, ls.Top, ls.Right, y1, button2);
            ls.AddArea(ls.Left, y1, ls.Right, ls.Bottom, button3);

            // give the two columns the same width and the two rows the same height
            ls.AddConstraint(new double[] { 2, -1 }, new Variable[] { x1, ls.Right }, OperatorType.EQ, 0);
            ls.AddConstraint(new double[] { 2, -1 }, new Variable[] { y1, ls.Bottom }, OperatorType.EQ, 0);

            le.LayoutSpec = ls;
        }
    }
}