using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.Layout;
using LinearProgramming;
using ALM;

namespace TestEdit
{
    public partial class Form1 : Form
    {
        ALMEngine le = new ALMEngine();

        public override LayoutEngine LayoutEngine
        {
            get { return le; }
        }

        public Form1()
        {
            InitializeComponent();

            LayoutSpec ls = new LayoutSpec();
            XTab x1 = ls.AddXTab();
            XTab x2 = ls.AddXTab();
            XTab x3 = ls.AddXTab();
            YTab y1 = ls.AddYTab();
            YTab y2 = ls.AddYTab();
            YTab y3 = ls.AddYTab();
            YTab y4 = ls.AddYTab();
            YTab y5 = ls.AddYTab();

            ls.AddArea(ls.Left, ls.Top, x1, y1, button1);
            ls.AddArea(x1, ls.Top, x2, y1, button2);
            ls.AddArea(ls.Left, y1, x1, y2, button3);
            ls.AddArea(x1, y1, x2, y2, button4);
            ls.AddArea(ls.Left, y2, x1, y3, button5);
            ls.AddArea(x1, y2, x2, y3, button6);

            // give the buttons the same size
            ls.AddConstraint(2, x1, -1, x2, OperatorType.EQ, 0);
            ls.AddConstraint(2, y1, -1, y2, OperatorType.EQ, 0);
            ls.AddConstraint(1, y1, 1, y2, -1, y3, OperatorType.EQ, 0);

            ls.AddArea(ls.Left, y3, x2, y4, checkedListBox1);
            ls.AddArea(x2, ls.Top, ls.Right, y2, textBox1);
            ls.AddArea(ls.Left, y4, x3, y5, listView1);
            ls.AddArea(x3, y2, ls.Right, y5, textBox2);

            Area richTextBox1Area = ls.AddArea(x2, y2, x3, y4, richTextBox1);
            richTextBox1Area.LeftMargin = richTextBox1Area.TopMargin
                = richTextBox1Area.RightMargin = richTextBox1Area.BottomMargin = 10;            

            Area label1Area = ls.AddArea(ls.Left, y5, x2, ls.Bottom, label1);
            label1Area.HAlignment = ALM.HorizontalAlignment.LEFT;
            label1Area.TopMargin = label1Area.BottomMargin = 4;
            
            Area label2Area = ls.AddArea(x2, y5, x3, ls.Bottom, label2);
            label2Area.HAlignment = ALM.HorizontalAlignment.CENTER;
            label2Area.TopMargin = label2Area.BottomMargin = 4;

            Area label3Area = ls.AddArea(x3, y5, ls.Right, ls.Bottom, label3);
            label3Area.HAlignment = ALM.HorizontalAlignment.RIGHT;
            label3Area.TopMargin = label3Area.BottomMargin = 4;

            le.LayoutSpec = ls;
            this.PerformLayout();
            le.Edit();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            
        }
    }
}