using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.Layout;
using ALM;

namespace TestRowColumnEdit
{
    public partial class Form1 : Form
    {
        ALMEngine le = new ALMEngine();

        public override LayoutEngine LayoutEngine
        {
            get { return le; }
        }

        public Form1()
        {
            InitializeComponent();
            LayoutSpec ls = new LayoutSpec();
            Column c1 = ls.AddColumn(ls.Left, null);
            Column c2 = ls.AddColumn();
            Column c3 = ls.AddColumn();
            Column c4 = ls.AddColumn();
            c2.InsertAfter(c1);
            c3.InsertAfter(c2);
            c4.InsertAfter(c3);
            Row r1 = ls.AddRow(ls.Top, null);
            Row r3 = ls.AddRow(null, ls.Bottom);
            r1.Next = r3;
            Row r2 = ls.AddRow();
            Row r4 = ls.AddRow();
            Row r5 = ls.AddRow();
            r2.InsertAfter(r1);
            r4.InsertAfter(r2);
            r5.InsertAfter(r4);

            Button b1 = new Button();
            b1.Text = "A1";
            Controls.Add(b1);
            Area a1 = ls.AddArea(r1, c1, b1);
            a1.HAlignment = ALM.HorizontalAlignment.LEFT;
            a1.VAlignment = VerticalAlignment.TOP;

            Button b2 = new Button();
            b2.Text = "A2";
            Controls.Add(b2);
            Area a2 = ls.AddArea(r2, c1, b2);
            a2.HAlignment = ALM.HorizontalAlignment.CENTER;
            a2.VAlignment = VerticalAlignment.CENTER;

            Button b3 = new Button();
            b3.Text = "A3";
            Controls.Add(b3);
            Area a3 = ls.AddArea(r3, c2, b3);
            a3.HAlignment = ALM.HorizontalAlignment.RIGHT;
            a3.VAlignment = VerticalAlignment.BOTTOM;
            
            Button b4 = new Button();
            b4.Text = "A4";
            Controls.Add(b4);
            Area a4 = ls.AddArea(r4, c3, b4);
            a4.HAlignment = ALM.HorizontalAlignment.CENTER;
            a4.VAlignment = VerticalAlignment.CENTER;

            Button b5 = new Button();
            b5.Text = "A5";
            Controls.Add(b5);
            Area a5 = ls.AddArea(r5, c4, b5);
            a4.HAlignment = ALM.HorizontalAlignment.CENTER;
            a4.VAlignment = VerticalAlignment.CENTER;

            //a2.Remove();
            //r2.Remove();

            r2.HasSameHeightAs(r1);
            r3.HasSameHeightAs(r1);
            r4.HasSameHeightAs(r1);
            r5.HasSameHeightAs(r1);

            le.LayoutSpec = ls;
            this.PerformLayout();
            le.Edit();
        }
    }
}